diff -U 1 libxinevdec.orig/dshowserver.c libxinevdec.patched_1.2_+_external-build/dshowserver.c
--- libxinevdec.orig/dshowserver.c	2008-07-29 20:31:40.000000000 +0000
+++ libxinevdec.patched_1.2_+_external-build/dshowserver.c	2008-08-04 09:52:41.000000000 +0000
@@ -87,2 +87,3 @@
   int64_t           video_step;
+  int64_t           pts;
   int               decoder_ok;
@@ -294,2 +297,7 @@
     this->size += buf->size;
+
+    /* store pts from first packet, it is not carried in last chunk */
+    if (buf->pts > 0)
+      this->pts = buf->pts;
+  
     if (! (buf->decoder_flags & BUF_FLAG_FRAME_END))
@@ -297,3 +305,3 @@
     this->ds_mpi.vd->cmd = VD_DECODE; //'2' is cmd for decoding
-    this->ds_mpi.vd->pts = buf->pts;
+    this->ds_mpi.vd->pts = this->pts;
     this->ds_mpi.vd->buflen = this->size;
@@ -318,3 +326,5 @@
       else
-        img->pts = buf->pts;
+        img->pts = this->pts;
+      this->pts = 0;
+
       img->bad_frame                    = 0;
